precision mediump float;
uniform sampler2D sTexture;//
//մӶɫĲ
varying vec4 ambient;
varying vec4 diffuse;
varying vec4 specular;
varying vec2 vTexPosition;
const float maxIterations = 99.0;//
const float zoom =0.5;//ϵ
const float xCenter = 0.0;//λ
const float yCenter = 0.0;
const vec3 innerColor = vec3(0.0, 0.0, 1.0);//ڲɫ
const vec3 outerColor1 = vec3(1.0, 0.0, 0.0);//ⲿɫ1
const vec3 outerColor2 = vec3(0.0, 1.0, 0.0);//ⲿɫ2
void main()                         
{    
   float real = vTexPosition.x * zoom + xCenter;//任ǰλ
	float imag = vTexPosition.y * zoom + yCenter;	
	float cReal = 0.32;//cʵ
	float cImag =0.043;//c鲿	
	float r2 = 0.0;//뾶ƽ
	float i;//  
	for(i=0.0; i<maxIterations && r2<4.0; i++){//ѭ
		float tmpReal = real;//浱ǰʵֵ		
		real = (tmpReal * tmpReal) - (imag * imag) +cReal;//һεʵֵ
		imag = 2.0 *tmpReal * imag +cImag;//һε鲿ֵ
		r2 = (real * real) + (imag * imag);//뾶ƽ
	}
    vec3 color;    
    if(r2 < 4.0){//r2δﵽ4˳ѭѴﵽֵ
    	color = innerColor;//Ϊڲɫֵ
    }else{//r24.0˳ѭλⲿ
    	color = mix(outerColor1, outerColor2, fract(i * 0.07));//Ϊⲿɫֵͬ
    }    
    vec4 finalColor=vec4(color, 1.0);
    gl_FragColor = finalColor*ambient+finalColor*specular+finalColor*diffuse;
}   